`timescale 1ns/1ns
module PCF8563_tb;

	reg Clk;
	reg Rst_n;
	
	reg Set_Time;
	reg [23:0]Time_to_Set;
	reg Set_Date;
	reg [31:0]Date_to_Set;
	reg Read;
	wire [23:0]Time_Read;
	wire [31:0]Date_Read;
	
	wire Cmd_Done;
	wire i2c_sclk;
	wire i2c_sdat;
	
	pullup PUP (i2c_sdat);

	PCF8563 PCF8563(
		.Clk(Clk),
		.Rst_n(Rst_n),		
		.Set_Time(Set_Time),
		.Time_to_Set(Time_to_Set),
		.Set_Date(Set_Date),
		.Date_to_Set(Date_to_Set),
		.Read(Read),
		.Time_Read(Time_Read),
		.Date_Read(Date_Read),
		.Cmd_Done(Cmd_Done),
		.i2c_sclk(i2c_sclk),
		.i2c_sdat(i2c_sdat)
	);
	
	M24LC04B M24LC04B(
		.A0(0), 
		.A1(0), 
		.A2(0), 
		.WP(0), 
		.SDA(i2c_sdat), 
		.SCL(i2c_sclk), 
		.RESET(~Rst_n)
	);
	
	initial Clk = 1;
	always #10 Clk = ~Clk;
	
	initial begin
		Rst_n = 0;
		Set_Time = 0;
		Set_Date = 0;
		Time_to_Set = 0;
		Date_to_Set = 0;
		Read = 0;
		#2001;
		Rst_n = 1;
		#80000;
		Time_to_Set = 24'h13_23_45;
		Set_Time = 1;
		#20;
		Set_Time = 0;
		#200;
		@(posedge Cmd_Done);
		#2000;
		
		Date_to_Set = 32'h84_13_23_45;
		Set_Date = 1;
		#20;
		Set_Date = 0;
		#200;
		@(posedge Cmd_Done);
		#2000;		
		
		Read = 1;
		#20;
		Read = 0;
		#200;
		@(posedge Cmd_Done);
		#20000;
		
		$stop;	
	end

endmodule
