`timescale 1ns/1ps

module phy_config_tb;
	
	reg  clk;        //模块时钟50MHz
	reg  rst_n;      //模块复位，低电平有效
	wire phy_rst_n;  //phy芯片复位，低电平有效
	wire mdc;        //时钟接口
	wire  mdio;       //数据接口
	wire [15:0] rddata;
	wire [7:0] led;
	wire phy_init;    //初始化完成标志，高电平有效
	
	pullup PUP(mdio);
	
	phy_config DUT(
		.clk      (clk),        //模块时钟50MHz
		.rst_n    (rst_n),      //模块复位，低电平有效
		.phy_rst_n(phy_rst_n),  //phy芯片复位，低电平有效
		.mdc      (mdc),        //时钟接口
		.mdio     (mdio),       //数据接口
//		.rddata   (),
		.led      (led),
		.phy_init (phy_init)    //初始化完成标志，高电平有效
	);
	
	defparam DUT.time_1s = 100;
	defparam DUT.time_10s = 400;
	defparam DUT.time_40us = 60;
	
	always #10 clk = ~clk;
	
	initial begin
		clk = 1;
		rst_n = 0;
		#201;
		rst_n = 1;
		
		@(posedge phy_init)
		
		#2000;
		
		$stop;
	end

endmodule

