/***************************************************
*	Module Name		:	ROM_top		   
*	Engineer			:	小梅哥
*	Target Device	:	10CL025YU256C8
*	Tool versions	:	Quartus Prime 18.1
*	Create Date		:	2021-12-20
*	Revision			:	v1.0
*	Description		:  ROM地址累加顶层控制
**************************************************/

module ROM_top(Clk,Rst_n,q);

	input Clk;
	input Rst_n;
	
	output [7:0]q;
	
	reg [7:0]addr;
	
	rom rom(
		.address(addr),
		.clock(Clk),
		.q(q)
	);
	
	always@(posedge Clk or negedge Rst_n)
	if(!Rst_n)
		addr <= 8'd0;
	else 
		addr <= addr + 1'b1;

endmodule
