/***************************************************
*	Module Name		:	PLL_LED		   
*	Engineer			:	小梅哥
*	Target Device	:	10CL025YU256C8
*	Tool versions	:	Quartus Prime 18.1
*	Create Date		:	2021-12-20
*	Revision			:	v1.0
*	Description		:  不同的时钟驱动2位LED
**************************************************/

module PLL_LED(
	Clk,
	Rst_n,
	LED
);

	input Clk;
	input Rst_n;
	output [1:0]LED;
	
	wire c0;	//25M   LED[0]
	wire c1;	//75M   LED[1]
	wire c2;	//100M  引出观察仿真
	
	wire locked;
	
	pll pll(
		.areset(~Rst_n),
		.inclk0(Clk),
		.c0(c0),
		.c1(c1),
		.c2(c2),
		.locked(locked)
	);
	
	counter
	#(
		.CNT_MAX(25'd24_999_999)
	)
	counter0(
		.Clk(c0),
		.Rst_n(Rst_n),
		.led(LED[0])
	);
	
	counter
	#(
		.CNT_MAX(25'd24_999_999)
	)
	counter1(
		.Clk(c1),
		.Rst_n(Rst_n),
		.led(LED[1])
	);

endmodule
